package Basic;
object GTree {
  sealed case class GRose[F[_],A](x : A, childs : F[GRose[F,A]])

  sealed trait GRose2[F[_],A]
  case class GFork[F[_],A](x : A, childs : F[GRose[F,A]]) extends GRose2[F,A]

  //val myRose2 : GRose2[List,Int] = GFork(3,Nil)

  trait Show[A] {
    def show(x: A) : String 
  }

  implicit object showInt extends Show[Int] {
    def show(x:Int) = x.toString()
  }

  case class ShowList[A](showA : Show[A]) extends Show[List[A]] {
    def show(x:List[A]) = show(x) //bottom
  }
  
  implicit def myShowList[a](implicit showA : Show[a]) = ShowList[a](showA)

  implicit object showList {
     def apply[B] (implicit showB : Show[B]) : Show[List[B]] = new ShowList[B](showB)
  }
  
  implicit val showList2 : {def apply[B] (implicit showB : Show[B]) : Show[List[B]]} = new {
     def apply[B] (implicit showB : Show[B]) : Show[List[B]] = new ShowList[B](showB)
  }

  case class ShowGRose[F[_],A](showA : Show[A], showF : {def apply[B] (implicit showB : Show[B]) : Show[F[B]]})
          extends Show[GRose[F,A]] {
    def show(x : GRose[F,A]) = show(x) // bottom
  }

  implicit def showGRose[F[_],A]
    (implicit showA : Show[A], showF : {def apply[B] (implicit showB : Show[B]) : Show[F[B]]}) : ShowGRose[F,A] =
      new ShowGRose[F,A](showA,showF)

  def test(rose : GRose[List,Int])(implicit showR : (Show[GRose[List,Int]])) : String = showR.show(rose)

  def showRose : String = test(myRose)(showGRose[List,Int](showInt,showList))   // there appears to be a bug here

  //val myRose2 : GRose[List,Int] = GRose(3,Nil) // bug

  val myRose : GRose[List,Int] = GRose[List,Int](3,Nil)
}
