package Generic;

import Isomorphism._

object TreeIso {
  sealed trait Tree[A]
  case class Empty[A] extends Tree[A]
  case class Fork[A](x:A, l : Tree[A], r : Tree[A]) extends Tree[A]
  
   def fromTree[a] = (l:Tree[a]) => l match {
      case Empty()      => Left({})
      case Fork(x,l,r)  => Right(x,(l,r))
    }
    
    def toTree[a] : Either[Unit,(a,(Tree[a],Tree[a]))] => Tree[a] = _ match {
      case Left(_)           => Empty()
      case Right((x,(l,r)))  => Fork(x,l,r)
    }
    
    def treeIso[a] : Iso[Tree[a],Either[Unit,(a,(Tree[a],Tree[a]))]] = 
      Iso[Tree[a],Either[Unit,(a,(Tree[a],Tree[a]))]] (fromTree) (toTree)
}