package Generic.Direct;

import Generic._
import Isomorphism._
import scala._

object Direct {
  def count[A] (x: A) (implicit ca : Count[A]) : Int =
    ca.count(x)
  
  trait Count[A] {
    type B
    
    def iso : Iso[A,B]
    def rep : Count[B]
    
    def count : A => Int = x => rep.count(iso.from(x))
  }
  
  trait CountSelf[A] extends Count[A] { // I'd like this to be orthogonal
    type B=A
    
    def iso = isoId
    def rep = this
  }
  
  implicit object CUnit extends CountSelf[Unit] {
    override def count = x => 0
  }
}