package Generic.GM;

import Generic._
import Isomorphism._
import scala._

object GMVisitor {
    trait Generic {
      type G <: TC
    
      def unit      : G {type A=Unit}
      def int       : G {type A=int}
      def char      : G {type A=char}
      def plus[a,b] : G {type A=a} => G {type A=b} => G {type A=Either[a,b]}
      def prod[a,b] : G {type A=a} => G {type A=b} => G {type A=(a,b)}
      def view[a,b] : Iso[b,a] => (=> G {type A=a}) => G {type A=b}
    }
    
    trait Rep[T] {
      def accept[g <: TC] (implicit gen : Generic {type G=g}) : g {type A=T}
    }
    
    def Rep[t] : {def apply[g<:TC] : Generic {type G=g} => g {type A=t}} => Rep[t] = g => 
      new Rep[t] {def accept[g <: TC](implicit gen : Generic {type G=g}) = g.apply(gen)}
    
    implicit def RUnit = Rep(new {def apply[g<:TC] = (gen : Generic {type G=g}) => gen.unit})
    implicit def RInt = Rep(new {def apply[g<:TC]  = (gen : Generic {type G=g}) => gen.int})
    implicit def RChar = Rep(new {def apply[g<:TC] = (gen : Generic {type G=g}) => gen.char})
    implicit def RPlus[a,b] (implicit a : Rep[a], b : Rep[b]) = 
      Rep(new {def apply[g<:TC] = (gen : Generic {type G=g}) => gen.plus(a.accept(gen))(b.accept(gen))})
    implicit def RProd[a,b] (implicit a : Rep[a], b : Rep[b]) = 
      Rep(new {def apply[g<:TC] = (gen : Generic {type G=g}) => gen.prod(a.accept(gen))(b.accept(gen))})
    
    //  A new generic function
    trait Size extends TC {def size : A => int}
    
    def Size[a] (f : a => int) = new Size {type A=a; def size = f}
	
    trait MySize extends Generic {
      type G=Size
      
      def unit      = Size((x:Unit) => 0)
      def int       = Size((x:Int) => 0)
      def char      = Size((x:Char) => 0)
      def plus[a,b] = a => b => Size((x:Either[a,b]) => x.fold(a.size, b.size))
      def prod[a,b] = a => b => Size((x:(a,b)) => a.size(x._1) + b.size(x._2))
      def view[a,b] = iso => a => Size((x:b) => a.size(iso.from(x)))
    }

    implicit object mySize extends MySize
    
    def size[a] (x : a) (implicit rep : Rep[a]) = 
      rep.accept(mySize).size(x)
}