package Generic.GM;

import Generic._
import Isomorphism._
import Generic.SerialUtil._
import GMVisitor._

object Serialization {
  // A new function
  trait Serial extends TC {
    def serial : A => String
  }
  
  def Serial[a] = (f : a => String) => new Serial {type A=a; def serial=f} 
    
  trait Serializer extends Generic {
    type G = Serial
      
    def unit       = Serial((x:Unit) => "")
    def int        = Serial(encodeInt)
    def char       = Serial(encodeChar)
    def plus[a,b]  = a => b => Serial((x:Either[a,b]) => x.fold("0" + a.serial(_), "1" + b.serial(_)))
    def prod[a,b]  = a => b => Serial((x:(a,b)) => a.serial(x._1) + b.serial(x._2))
    def view[a,b]  = iso => a => Serial((x:b) => a.serial(iso.from(x)))
  }
  
  implicit object basicSerializer extends Serializer // Provides an implicit object of type Serialize
  
  def serial[t] (x : t) (implicit r : Rep[t]) = 
    r.accept(basicSerializer).serial(x)
  
  trait DeSerial extends TC {
    def deSerial : String => (A,String)
  }
  /*
  def DeSerial[a] = (f : String => (a,String)) => new DeSerial {type A=a; def deSerial=f}
  
  trait DeSerializer extends Generic {
    type G = DeSerial
      
    def unit       = DeSerial(x => ({},""))
    def int        = DeSerial(decodeInt)
    def char       = DeSerial(decodeChar)
    def plus[a,b]  = a => b => DeSerial((x:String) => 
      if (x.substring(0,1).equals("0")) {
        def prod = a.deSerial(x.substring(1))
        (Left(prod._1),prod._2)
      } else {
        def prod = b.deSerial(x.substring(1))
        (Right(prod._1),prod._2)
      }) // do we need to test if x = ""?
    def prod[a,b]  = a => b => DeSerial(x => {
      def prod1 = a.deSerial(x)
      def prod2 = b.deSerial(prod1._2)
      ((prod1._1,prod2._1),prod2._2)
    })
    def view[a,b]  = iso => a => DeSerial(x => {
      def prod = a.deSerial(x)
      (iso.to(prod._1),prod._2)
    })
  }
  
  implicit object basicDeSerializer extends DeSerializer
    
  def deSerial[t] (x : String) (implicit r : Rep[t]) : t = 
    r.accept(basicDeSerializer).deSerial(x)._1
  */
}