package Generic.HODGP;

object Problem {
  case class NatF[r]
  case class Zero[r] extends NatF[r]
  case class Succ[r](n:r) extends NatF[r]
  
  case class Nat(out : NatF[Nat])
  
  def mapNatF[a,b] (f : a => b) : NatF[a] => NatF[b] = {
    case Zero()   => Zero()
    case Succ(n)  => Succ(f(n))
  }
  
  def cataNat[r] (f : NatF[r] => r) : Nat => r = 
    f compose mapNatF(cataNat(f)) compose ((x:Nat) => x.out)
  
  def cataNat2[r] (f : NatF[r] => r) : Nat => r = 
    n => (f compose mapNatF(cataNat2(f)) compose ((x:Nat) => x.out))(n)
  
  def zero : Nat = Nat(Zero())
  def succ(n:Nat) : Nat = Nat(Succ(n))
  
  def toInt1 = cataNat[int] {case Zero() => 0; case Succ(n) => 1 + n}
  def toInt2 = cataNat2[int] {case Zero() => 0; case Succ(n) => 1 + n}
}