package Generic;

import Isomorphism._

object ListIso {
   def fromList[a] = (l:List[a]) => l match {
      case Nil      => Left({})
      case (x::xs)  => Right(x,xs)
    }
    
    def toList[a] = (s : Either[Unit,(a,List[a])]) => s match {
      case Left(_)       => Nil
      case Right((x,xs)) => x :: xs
    }
    
    def listIso[a] : Iso[List[a],Either[Unit,(a,List[a])]] = Iso[List[a],Either[Unit,(a,List[a])]] (fromList) (toList)
}