package Generic.Rep;

import Generic._
import Isomorphism._
import scala._

object Rep {
  sealed trait Rep[A]
  implicit object RUnit extends Rep[Unit]
  implicit object RInt  extends Rep[Int]
  implicit object RChar extends Rep[Char]
  case class RProd[A,B](ra : Rep[A], rb : Rep[B]) extends Rep[(A,B)]
  case class RPlus[A,B](ra : Rep[A], rb : Rep[B]) extends Rep[Either[A,B]]
  case class RView[A,B](iso : Iso[B,A], ra : () => Rep[A]) extends Rep[B] // cannot make ra lazy, why?
  
  implicit def RepProd[a,b](implicit ra : Rep[a], rb : Rep[b]) = RProd(ra,rb)
  implicit def RepPlus[a,b](implicit ra : Rep[a], rb : Rep[b]) = RPlus(ra,rb)
  
  def size[a] (x:a) (implicit rep : Rep[a]) : int = 
    rep match {
      case RUnit         => 0
      case RInt          => 0
      case RChar         => 0
      case RProd(a,b)    => size(x._1)(a) + size(x._2)(b)
      case RPlus(a,b)    => x.fold(size(_)(a),size(_)(b))
      case RView(iso,a)  => size(iso.from(x))(a())
    }
}