package Generic.Rep;

import Generic._
import Isomorphism._
import Generic.SerialUtil._
import Rep._

object Serialization {
  // A new function
  def serial[t] (x : t) (implicit r : Rep[t]) : String = 
    r match {
      case RUnit         => ""
      case RInt          => encodeInt(x)
      case RChar         => encodeChar(x)
      case RPlus(a,b)    => x.fold("0" + serial(_)(a), "1" + serial(_)(b))
      case RProd(a,b)    => serial(x._1)(a) + serial(x._2)(b)
      case RView(iso,a)  => serial(iso.from(x))(a())
    }
  
  def fst[a,b] = (x:(a,b)) => x._1 
  
  def deSerialize[t] (x : String) (implicit r : Rep[t]) : (t,String) = 
    r match {
      case RUnit       => ({},"")
      case RInt        => decodeInt(x)
      case RChar       => decodeChar(x)
      case RPlus(a,b)  => 
        if (x.substring(0,1).equals("0")) {
          def prod = deSerialize(x.substring(1))(a)
          (Left(prod._1),prod._2)
        } else {
          def prod = deSerialize(x.substring(1))(b)
          (Right(prod._1),prod._2)
        } // do we need to test if x = ""?
      case RProd(a,b)  => {
        def prod1 = deSerialize(x)(a)
        def prod2 = deSerialize(prod1._2)(b)
        ((prod1._1,prod2._1),prod2._2)
      }
      case RView(iso,a)  => {
        def prod = deSerialize(x)(a())
        (iso.to(prod._1),prod._2)
      }
    }
  
  def deSerial[t] (x : String) (implicit r : Rep[t]) : t = deSerialize(x)(r)._1  
}