package Generic;

import Isomorphism._

object SerialUtil {
  def repeat (c : char,times : int) : String = {
    var sb : StringBuffer = new StringBuffer()
    var t = times
    
    while (t > 0) {
      sb.append(c);
      t = t - 1;
    }
    
    return sb.toString();
  }
  
  def encodeIntegral(x : int,size : int) : String = {
    def s = Integer.toBinaryString(x);
    return (repeat('0',size - s.length()) + s)
  }
  
  def encodeInt  : int => String = x => encodeIntegral(x,32)
  def encodeChar : char => String = x => encodeIntegral(x.asInstanceOf[int],8)
  
  def exp(x : int, y : int) : int = {
    var i = 0;
    var value = 1;
    
    while (i < y) {
      value = x * value;
      
      i = i + 1;
    }
    
    return value;
  }
  
  def decodeIntegral(x : String) : int = {
    def sb : StringBuffer = new StringBuffer(x).reverse();
    def len = x.length();
    var value = 0;
    
    var i : int = 0;
    while (i < len) {
      if (sb.charAt(i).equals('1')) value = exp(2,i) + value; 
      i = i + 1;
    }
    
    return value;
  }
  
  def decodeInt(x:String) : (int,String) = {
    def rest : String = x.substring(32)
    def value = x.substring(0,32)
    
    return (decodeIntegral(value),rest)
  }
  
  def decodeChar(x : String) : (char,String) = {
    def rest : String = x.substring(8)
    def value = x.substring(0,8)
    
    return (decodeIntegral(value).asInstanceOf[char],rest)
  }
  
  //def test = Integer.toBinaryString(333)
}
