package Generic;

import Isomorphism._

object BTreeIso {
  sealed trait Tree[A]
  case class Value[A](x : A) extends Tree[A]
  case class Fork[A](x:Int, l : Tree[A], r : Tree[A]) extends Tree[A]
  
   def fromTree[a] = (l:Tree[a]) => l match {
      case Value(x)     => Left(x)
      case Fork(x,l,r)  => Right(x,(l,r))
    }
    
    def toTree[a] : Either[a,(Int,(Tree[a],Tree[a]))] => Tree[a] = _ match {
      case Left(x)           => Value(x)
      case Right((x,(l,r)))  => Fork(x,l,r)
    }
    
    def treeIso[a] : Iso[Tree[a],Either[a,(Int,(Tree[a],Tree[a]))]] = 
      Iso[Tree[a],Either[a,(Int,(Tree[a],Tree[a]))]] (fromTree) (toTree)
}