package Intro;

import scala._

object Intro {
  def square(x : Double) : Double = x * x 
  
  def twice(f : Int => Int, x : Int) : Int = f (f (x))
  
  def power1(x : Int) : Int = twice((y : Int) => y * y, x)
  
  def twiceCurry (f : Int => Int) (x : Int) : Int = f (f (x))
  
  def  comp[a,b,c] (f : b => c) (g : a => b) (x : a) : c = 
     f (g (x))
  
  def power2(x : Int) = twice(y => y * y, x)
  
  trait Hello {
    val hello         = "Hello!"
  }
    
  trait HowAreU {
    val howAreU       = "How are you?"
  }
    
  trait WhatIsUrName {
    val whatIsUrName  = "What is your name?"
  }

  trait Shout {
    def shout(str : String) : String
  }
  
  trait  Basics  extends Hello with HowAreU 
               with WhatIsUrName with Shout {
    val greet                = hello + " " + howAreU
    def shout(str : String)  = str.toUpperCase()
  }
               
  def basics1 = new Basics(){}
               
  object basics2 extends Basics
  
  trait List[A]
  case class Nil[A] extends List[A]
  case class Cons[A](x : A, xs : List[A]) extends List[A]
  
  val leftVal : Either[Int,Char] = Left(1)
  val rightVal : Either[Int,Char] = Right('c')
  
  def stringVal(x : Either[Int,Char]) = x.fold(y => y.toString(),y => y)
  
  val prodVal : (Int,Char) = (3,'c')
  
  val fstVal = prodVal._1
  val sndVal = prodVal._2
  
  def len[a](l : List[a]) : Int = l match {
    case Nil()       => 0
    case Cons(x,xs)  => 1 + len(xs)
  }

  def ins[a <: Ordered[a]] (x : a, l : List[a]) : List[a] = 
    l match {
      case Nil()        => Cons(x,Nil[a])
      case Cons(y,ys)   =>  if (x <= y) Cons(x,Cons(y,ys)) 
                            else Cons(y, ins(x,ys))
  }
  
  val alist = Cons(3,Cons(2,Cons(1,Nil())))
  
  trait Iterable[A, Container[_]] { 
    def map[B](f: A => B): Container[B] 
    def filter(p: A => Boolean): Container[A] 
  }
  
  trait SetInt {
    type Set[_]
    type A
  
    def empty  : Set[A] 
    def insert (x : A, q : Set[A]) : Set[A]
    def extract (q : Set[A]) : Option[(A, Set[A])]
  }
  
  trait SetOrdered extends SetInt {
    type Set[X]=List[X]
    type A <: Ordered[A]
    
    def empty = Nil()
    def insert(x : A, q : Set[A]) = ins(x,q)
    def extract(q : Set[A]) = 
      q match {
        case Nil()       => None
        case Cons(x,xs)  => Some(x,xs)
      }
  }
}